#===============================================================================

import machine, uos
from machine import Pin
from time import sleep

#===============================================================================

pin1 = Pin(16, Pin.OUT)
pin2 = Pin(5,  Pin.OUT)
pin3 = Pin(4,  Pin.OUT)
pin4 = Pin(0,  Pin.OUT) 

tiempo = 0.005
#tiempo = 0.5

#===============================================================================

WaveDrive=[
  [1,0,0,0],
  [0,1,0,0],
  [0,0,1,0],
  [0,0,0,1]]

FullStepDrive=[
  [1,0,0,1],
  [1,1,0,0],
  [0,1,1,0],
  [0,0,1,1]]

HalfStepDrive=[
  [1,0,0,1],
  [1,0,0,0],
  [1,1,0,0],
  [0,1,0,0],
  [0,1,1,0],
  [0,0,1,0],
  [0,0,1,1],
  [0,0,0,1]]
  
#Secuencias sentido de giro HORARIO
#===============================================================================

def secuenciaWaveDrive_horario(tiempo):
  for indice in range(2048):
    pin1.value(WaveDrive[indice%4][3])
    pin2.value(WaveDrive[indice%4][2])
    pin3.value(WaveDrive[indice%4][1])
    pin4.value(WaveDrive[indice%4][0])
    sleep(tiempo)      
      
#Secuencias sentido de giro AHORARIO    
#===============================================================================    
def secuenciaWaveDrive_Ahorario(tiempo):
  for indice in range(2048):
    pin1.value(WaveDrive[indice%4][0])
    pin2.value(WaveDrive[indice%4][1])
    pin3.value(WaveDrive[indice%4][2])
    pin4.value(WaveDrive[indice%4][3])
    sleep(tiempo)
      
#===============================================================================    
def secuenciaParo():
  pin1.value(0)
  pin2.value(0)
  pin3.value(0)
  pin4.value(0)
  sleep(tiempo) 

#=============================================================================== 

def giroGrados(grados,tiempo):
  if(grados>=0):
    for indice in range(int((2048/360)*grados)):    
      pin1.value(WaveDrive[indice%4][3])                #horario
      pin2.value(WaveDrive[indice%4][2])
      pin3.value(WaveDrive[indice%4][1])
      pin4.value(WaveDrive[indice%4][0])
      sleep(tiempo)
  else: 
    for indice in range(int((2048/360)*abs(grados))):  
      pin1.value(WaveDrive[indice%4][0])                #Ahorario
      pin2.value(WaveDrive[indice%4][1])
      pin3.value(WaveDrive[indice%4][2])
      pin4.value(WaveDrive[indice%4][3])
      sleep(tiempo)
#=============================================================================== 

def main():
  try:
    uos.dupterm(None)
    uart = machine.UART(0)                 
    uart.init(115200,bits=8,parity=None,stop=1)  
  except Exception:
    print("No se puede usar el puerto serie\r\n")   
  else:
    uart.write("Posicion inicial: 0 grados\r\n")
    i=0
    while True:
      if uart.any():
        recibido = uart.readline()
        try:
          grados=int(recibido)     
          uart.write("Desplazando eje del motor...\r\n") 
          giroGrados(grados,tiempo)  
          uart.write("Nueva posicion: "+str(grados)+"\r\n")    
          i=1
        except:
          if i==1:
            uart.write("No es un numero entero\r\n")    
            
  finally:
    uos.dupterm(machine.UART(0,115200))

#===============================================================================

main()#Funcion principal

#===============================================================================




























